using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.OleDb;

namespace SAS.CustomTasks.AreaBar
{
	/// <summary>
	/// Summary description for AreaBarForm.
	/// </summary>
	public class AreaBarForm : System.Windows.Forms.Form
	{
		#region Windows Form Designer generated code

		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.ComboBox cmbServers;
		private System.Windows.Forms.ComboBox cmbDatasets;
		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.ComboBox cmbLibs;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label7;
		private SAS.CustomTasks.AreaBar.IconComboBox cmbCategoryVar;
		private SAS.CustomTasks.AreaBar.IconComboBox cmbResponseVar;
		private SAS.CustomTasks.AreaBar.IconComboBox cmbWidthVar;
		private System.Windows.Forms.RadioButton rbPercentageWidth;
		private System.Windows.Forms.RadioButton rbSumWidth;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.CheckBox checkBox1;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.RadioButton rbPercentageSubgroup;
		private SAS.CustomTasks.AreaBar.IconComboBox cmbSubgroupVar;
		private System.Windows.Forms.RadioButton rbSumSubgroup;
		private System.Windows.Forms.StatusBar statusBar1;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public AreaBarForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(AreaBarForm));
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.cmbServers = new System.Windows.Forms.ComboBox();
			this.cmbLibs = new System.Windows.Forms.ComboBox();
			this.label3 = new System.Windows.Forms.Label();
			this.cmbDatasets = new System.Windows.Forms.ComboBox();
			this.btnOK = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.label4 = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.label6 = new System.Windows.Forms.Label();
			this.label7 = new System.Windows.Forms.Label();
			this.cmbCategoryVar = new SAS.CustomTasks.AreaBar.IconComboBox();
			this.cmbResponseVar = new SAS.CustomTasks.AreaBar.IconComboBox();
			this.cmbWidthVar = new SAS.CustomTasks.AreaBar.IconComboBox();
			this.rbPercentageWidth = new System.Windows.Forms.RadioButton();
			this.rbSumWidth = new System.Windows.Forms.RadioButton();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.checkBox1 = new System.Windows.Forms.CheckBox();
			this.label8 = new System.Windows.Forms.Label();
			this.cmbSubgroupVar = new SAS.CustomTasks.AreaBar.IconComboBox();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.rbSumSubgroup = new System.Windows.Forms.RadioButton();
			this.rbPercentageSubgroup = new System.Windows.Forms.RadioButton();
			this.statusBar1 = new System.Windows.Forms.StatusBar();
			this.groupBox1.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 12);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(120, 20);
			this.label1.TabIndex = 0;
			this.label1.Text = "Select a ser&ver:";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 45);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(120, 18);
			this.label2.TabIndex = 2;
			this.label2.Text = "Select a &library:";
			// 
			// cmbServers
			// 
			this.cmbServers.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbServers.Location = new System.Drawing.Point(128, 12);
			this.cmbServers.Name = "cmbServers";
			this.cmbServers.Size = new System.Drawing.Size(240, 21);
			this.cmbServers.TabIndex = 1;
			this.cmbServers.SelectedIndexChanged += new System.EventHandler(this.cmbServers_SelectedIndexChanged);
			// 
			// cmbLibs
			// 
			this.cmbLibs.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbLibs.Location = new System.Drawing.Point(128, 44);
			this.cmbLibs.Name = "cmbLibs";
			this.cmbLibs.Size = new System.Drawing.Size(240, 21);
			this.cmbLibs.TabIndex = 3;
			this.cmbLibs.SelectedIndexChanged += new System.EventHandler(this.cmbLibs_SelectedIndexChanged);
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(8, 79);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(112, 18);
			this.label3.TabIndex = 4;
			this.label3.Text = "Select a &data set:";
			// 
			// cmbDatasets
			// 
			this.cmbDatasets.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbDatasets.Location = new System.Drawing.Point(129, 78);
			this.cmbDatasets.Name = "cmbDatasets";
			this.cmbDatasets.Size = new System.Drawing.Size(240, 21);
			this.cmbDatasets.TabIndex = 5;
			this.cmbDatasets.SelectedIndexChanged += new System.EventHandler(this.cmbDatasets_SelectedIndexChanged);
			// 
			// btnOK
			// 
			this.btnOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnOK.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnOK.Location = new System.Drawing.Point(200, 456);
			this.btnOK.Name = "btnOK";
			this.btnOK.Size = new System.Drawing.Size(80, 24);
			this.btnOK.TabIndex = 18;
			this.btnOK.Text = "OK";
			// 
			// btnCancel
			// 
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnCancel.Location = new System.Drawing.Point(288, 456);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.Size = new System.Drawing.Size(80, 24);
			this.btnCancel.TabIndex = 19;
			this.btnCancel.Text = "Cancel";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(8, 111);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(144, 24);
			this.label4.TabIndex = 6;
			this.label4.Text = "Task Role Assignments";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(8, 141);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(72, 24);
			this.label5.TabIndex = 7;
			this.label5.Text = "Cate&gory:";
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(8, 171);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(72, 24);
			this.label6.TabIndex = 9;
			this.label6.Text = "&Response:";
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(8, 203);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(72, 24);
			this.label7.TabIndex = 11;
			this.label7.Text = "&Width:";
			// 
			// cmbCategoryVar
			// 
			this.cmbCategoryVar.DrawMode = System.Windows.Forms.DrawMode.OwnerDrawFixed;
			this.cmbCategoryVar.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbCategoryVar.Location = new System.Drawing.Point(129, 143);
			this.cmbCategoryVar.Name = "cmbCategoryVar";
			this.cmbCategoryVar.Size = new System.Drawing.Size(240, 21);
			this.cmbCategoryVar.TabIndex = 8;
			this.cmbCategoryVar.SelectedIndexChanged += new System.EventHandler(this.cmbCategoryVar_SelectedIndexChanged);
			// 
			// cmbResponseVar
			// 
			this.cmbResponseVar.DrawMode = System.Windows.Forms.DrawMode.OwnerDrawFixed;
			this.cmbResponseVar.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbResponseVar.Location = new System.Drawing.Point(129, 173);
			this.cmbResponseVar.Name = "cmbResponseVar";
			this.cmbResponseVar.Size = new System.Drawing.Size(240, 21);
			this.cmbResponseVar.TabIndex = 10;
			this.cmbResponseVar.SelectedIndexChanged += new System.EventHandler(this.cmbResponseVar_SelectedIndexChanged);
			// 
			// cmbWidthVar
			// 
			this.cmbWidthVar.DrawMode = System.Windows.Forms.DrawMode.OwnerDrawFixed;
			this.cmbWidthVar.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbWidthVar.Location = new System.Drawing.Point(129, 205);
			this.cmbWidthVar.Name = "cmbWidthVar";
			this.cmbWidthVar.Size = new System.Drawing.Size(240, 21);
			this.cmbWidthVar.TabIndex = 12;
			this.cmbWidthVar.SelectedIndexChanged += new System.EventHandler(this.cmbWidthVar_SelectedIndexChanged);
			// 
			// rbPercentageWidth
			// 
			this.rbPercentageWidth.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.rbPercentageWidth.Location = new System.Drawing.Point(24, 24);
			this.rbPercentageWidth.Name = "rbPercentageWidth";
			this.rbPercentageWidth.Size = new System.Drawing.Size(96, 16);
			this.rbPercentageWidth.TabIndex = 0;
			this.rbPercentageWidth.Text = "&Percentage";
			this.rbPercentageWidth.CheckedChanged += new System.EventHandler(this.rbPercentageWidth_CheckedChanged);
			// 
			// rbSumWidth
			// 
			this.rbSumWidth.Checked = true;
			this.rbSumWidth.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.rbSumWidth.Location = new System.Drawing.Point(24, 48);
			this.rbSumWidth.Name = "rbSumWidth";
			this.rbSumWidth.Size = new System.Drawing.Size(96, 16);
			this.rbSumWidth.TabIndex = 1;
			this.rbSumWidth.TabStop = true;
			this.rbSumWidth.Text = "&Sum";
			this.rbSumWidth.CheckedChanged += new System.EventHandler(this.rbSumWidth_CheckedChanged);
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.rbPercentageWidth);
			this.groupBox1.Controls.Add(this.rbSumWidth);
			this.groupBox1.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.groupBox1.Location = new System.Drawing.Point(128, 232);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(136, 72);
			this.groupBox1.TabIndex = 13;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Specify Width as";
			// 
			// checkBox1
			// 
			this.checkBox1.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.checkBox1.Location = new System.Drawing.Point(8, 311);
			this.checkBox1.Name = "checkBox1";
			this.checkBox1.Size = new System.Drawing.Size(128, 24);
			this.checkBox1.TabIndex = 14;
			this.checkBox1.Text = "Speci&fy Subgroup";
			this.checkBox1.CheckStateChanged += new System.EventHandler(this.checkBox1_CheckStateChanged);
			// 
			// label8
			// 
			this.label8.Enabled = false;
			this.label8.Location = new System.Drawing.Point(8, 342);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(88, 24);
			this.label8.TabIndex = 15;
			this.label8.Text = "Sub&group:";
			// 
			// cmbSubgroupVar
			// 
			this.cmbSubgroupVar.DrawMode = System.Windows.Forms.DrawMode.OwnerDrawFixed;
			this.cmbSubgroupVar.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbSubgroupVar.Enabled = false;
			this.cmbSubgroupVar.Location = new System.Drawing.Point(129, 344);
			this.cmbSubgroupVar.Name = "cmbSubgroupVar";
			this.cmbSubgroupVar.Size = new System.Drawing.Size(240, 21);
			this.cmbSubgroupVar.TabIndex = 16;
			this.cmbSubgroupVar.SelectedIndexChanged += new System.EventHandler(this.cmbSubgroupVar_SelectedIndexChanged);
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.rbSumSubgroup);
			this.groupBox2.Controls.Add(this.rbPercentageSubgroup);
			this.groupBox2.Enabled = false;
			this.groupBox2.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.groupBox2.Location = new System.Drawing.Point(128, 373);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(136, 72);
			this.groupBox2.TabIndex = 17;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Specify Subgroup as";
			// 
			// rbSumSubgroup
			// 
			this.rbSumSubgroup.Checked = true;
			this.rbSumSubgroup.Enabled = false;
			this.rbSumSubgroup.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.rbSumSubgroup.Location = new System.Drawing.Point(24, 43);
			this.rbSumSubgroup.Name = "rbSumSubgroup";
			this.rbSumSubgroup.Size = new System.Drawing.Size(96, 16);
			this.rbSumSubgroup.TabIndex = 1;
			this.rbSumSubgroup.TabStop = true;
			this.rbSumSubgroup.Text = "Su&m";
			this.rbSumSubgroup.CheckedChanged += new System.EventHandler(this.rbSumSubgroup_CheckedChanged);
			// 
			// rbPercentageSubgroup
			// 
			this.rbPercentageSubgroup.Enabled = false;
			this.rbPercentageSubgroup.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.rbPercentageSubgroup.Location = new System.Drawing.Point(24, 21);
			this.rbPercentageSubgroup.Name = "rbPercentageSubgroup";
			this.rbPercentageSubgroup.Size = new System.Drawing.Size(88, 16);
			this.rbPercentageSubgroup.TabIndex = 0;
			this.rbPercentageSubgroup.Text = "Percen&tage";
			this.rbPercentageSubgroup.CheckedChanged += new System.EventHandler(this.rbPercentageSubgroup_CheckedChanged);
			// 
			// statusBar1
			// 
			this.statusBar1.Location = new System.Drawing.Point(0, 494);
			this.statusBar1.Name = "statusBar1";
			this.statusBar1.Size = new System.Drawing.Size(376, 16);
			this.statusBar1.TabIndex = 20;
			// 
			// AreaBarForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(376, 510);
			this.Controls.Add(this.statusBar1);
			this.Controls.Add(this.groupBox2);
			this.Controls.Add(this.cmbSubgroupVar);
			this.Controls.Add(this.label8);
			this.Controls.Add(this.checkBox1);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.cmbWidthVar);
			this.Controls.Add(this.cmbResponseVar);
			this.Controls.Add(this.cmbCategoryVar);
			this.Controls.Add(this.label7);
			this.Controls.Add(this.label6);
			this.Controls.Add(this.label5);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.btnOK);
			this.Controls.Add(this.cmbDatasets);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.cmbLibs);
			this.Controls.Add(this.cmbServers);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MaximumSize = new System.Drawing.Size(384, 544);
			this.MinimizeBox = false;
			this.MinimumSize = new System.Drawing.Size(384, 544);
			this.Name = "AreaBarForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "Area Bar Chart";
			this.Load += new System.EventHandler(this.AreaBarForm_Load);
			this.groupBox1.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#region Properties for this add-in task
		/// <summary>		
		/// ISASTaskConsumer, our hook to the host application for services
		/// </summary>		
		public SAS.Shared.AddIns.ISASTaskConsumer Consumer		
		{		
			set	{ consumer = value; }
		}
		private SAS.Shared.AddIns.ISASTaskConsumer consumer = null;

		public string CurrentServer
		{
			set	{ currServer = value; }
			get	{ return currServer;  }
		}
		private string currServer = string.Empty;
		
		public string Library
		{
			set	{ library = value; }
			get	{ return library; }
		}
		private string library;
		
		public string DataSetName
		{
			set	{ dataset = value; }
			get	{ return dataset; }
		}
		private string dataset = string.Empty;

		public string CategoryVar
		{
			set	{ categoryVar = value; }
			get	{ return categoryVar;}
		}
		private string categoryVar;		
		
		public string ResponseVar
		{
			set	{ responseVar = value; }
			get	{ return responseVar; }
		}
		private string responseVar;
		
		public string WidthVar
		{
			set	{ widthVar = value; }
			get	{ return widthVar; }
		}
		private string widthVar;

		public string WSTAT
		{
			set	{ wstat = value; }
			get	{ return wstat;  }
		}
		private string wstat = "SUM";		

		public string SubgroupVar
		{
			set	{ subgroupVar = value; }
			get	{ return subgroupVar; }
		}
		private string subgroupVar;

		public bool ShowSubgroup
		{
			set	{ bShowSubgroup = value; }
			get	{ return bShowSubgroup;  }
		}
		private bool bShowSubgroup;
		
		public string RSTAT
		{
			set	{ rstat = value; }
			get	{ return rstat;  }
		}		
		private string rstat = "SUM";
		
		#endregion

		#region UI methods

		private bool bUpdate = false;

		enum Role
		{
			CATEGORY,
			RESPONSE,
			WIDTH,
			SUBGROUP
		}

		private ImageList imgList = new ImageList();

		private void AreaBarForm_Load(object sender, System.EventArgs e)
		{
			imgList.Images.Add(Global.GetImageFromResources("AreaBar.Type_Char.ico", new Size(16,16)));
			imgList.Images.Add(Global.GetImageFromResources("AreaBar.Type_Num.ico", new Size(16,16)));

			cmbCategoryVar.ImageList = imgList;
			cmbResponseVar.ImageList = imgList;
			cmbWidthVar.ImageList = imgList;
			cmbSubgroupVar.ImageList = imgList;

			if (consumer == null)
				throw new System.Exception("Must set ISASTaskConsumer as Consumer property!");
			
			// get the list of available servers from the application
			string[] servers;
			consumer.Servers(out servers);
			
			if (servers.Length == 0)
				throw new System.Exception("No servers are available!");
			
			// populate the servers combobox
			cmbServers.Items.AddRange(servers);
			
			if (consumer.AssignedServer.Length > 0)
			{
				cmbServers.SelectedItem = (currServer == string.Empty) ? consumer.AssignedServer : currServer;
				if (!bUpdate)
				{
					bUpdate = true;
					
					if (dataset == string.Empty)
					{
						SAS.Shared.AddIns.ISASTaskData activeData = consumer.ActiveData;
						if (activeData != null)
						{
							cmbLibs.SelectedItem = activeData.Library;
							cmbDatasets.SelectedItem = activeData.Member;
						}
					}
				}
			}
			currServer = cmbServers.SelectedItem.ToString();

			rbSumWidth.Checked = (wstat == "SUM");
			rbPercentageWidth.Checked = (wstat == "PERCENT");

			checkBox1.Checked = bShowSubgroup;

			rbSumSubgroup.Checked = (rstat == "SUM");
			rbPercentageSubgroup.Checked = (rstat == "PERCENT");
		}

		private void PopulateLibraryList()
		{
			Cursor c = Cursor.Current;
			Cursor.Current = Cursors.WaitCursor;
			
			cmbLibs.Items.Clear();
			string[] libs;
			consumer.Libraries(cmbServers.SelectedItem.ToString(), out libs);
			
			if (libs.Length == 0)
			{
				Cursor.Current = c;
				throw new System.Exception("No libraries are available!");
			}
			
			cmbLibs.Items.AddRange(libs);
			cmbLibs.Sorted = true;
			
			if (cmbLibs.Items.Contains(library))
				cmbLibs.SelectedItem = library;
			else
			{
				cmbLibs.Text = string.Empty;
				cmbDatasets.Items.Clear();
				dataset = string.Empty;
			}

			PopulateVariableList();

			Cursor.Current = c;
		}
		/// <summary>
		/// Use the Workspace property of the ISASTaskConsumer and the SAS IOM OLEDB 
		/// Provider to connect to the SAS session and query for additional information 
		/// about the SAS data.
		/// </summary>
		/// <param name="libname"></param>
		private void PopulateDatasetList(string libname)
		{
			Cursor c = Cursor.Current;
			Cursor.Current = Cursors.WaitCursor;
			
			cmbDatasets.Items.Clear();

			string server = string.Empty;

			SAS.Workspace ws = null;
			try
			{
				server = consumer.AssignedServer;

				ws = consumer.Workspace(server) as SAS.Workspace;		
			}
			catch (Exception ex)
			{
				throw new System.Exception("ISASTaskConsumer.Workspace is not usable!",ex);
			}

			if (server.Length > 0 && ws != null)
			{
				// Use the SAS IOM OLEDB provider to read data from the SAS workspace
				OleDbConnection dbConnection = new OleDbConnection( "Provider=sas.iomprovider.1; SAS Workspace ID=" + ws.UniqueIdentifier );
				try
				{
					dbConnection.Open();
					// Use the SASHELP.VSTABVW view to get the names of all the data sets specified in the library
					string library = libname;
					string selectclause = "select * from sashelp.vstabvw where libname='" + library + "'";
					OleDbCommand cmdDB = new OleDbCommand( selectclause, dbConnection );
					OleDbDataReader dataReader = cmdDB.ExecuteReader( CommandBehavior.CloseConnection );

					try
					{
						while (dataReader.Read())
						{			
							string dataset = dataReader["memname"].ToString();

							// populate the datasets combobox
							cmbDatasets.Items.Add(dataset);
						}
					}
					finally
					{
						dataReader.Close();
					}
				}
				catch{}
				finally
				{
					dbConnection.Close();
				}
			}

			if (cmbDatasets.Items.Contains(this.dataset))
				cmbDatasets.SelectedItem = this.dataset;		

			Cursor.Current = c;
		}
		/// <summary>
		/// Use the Workspace property of the ISASTaskConsumer and the SAS IOM OLEDB 
		/// Provider to connect to the SAS session and query for the column names.
		/// </summary>
		/// <param name="libname"></param>
		private void PopulateVariableList()
		{
			cmbCategoryVar.Items.Clear();
			cmbResponseVar.Items.Clear();
			cmbWidthVar.Items.Clear();
			cmbSubgroupVar.Items.Clear();

			groupBox1.Enabled = false;

			string server = string.Empty;

			SAS.Workspace ws = null;
			try
			{
				server = consumer.AssignedServer;

				ws = consumer.Workspace(server) as SAS.Workspace;		
			}
			catch (Exception ex)
			{
				throw new System.Exception("ISASTaskConsumer.Workspace is not usable!",ex);
			}

			if (server.Length > 0 && ws != null)
			{
				// Use the SAS IOM OLEDB provider to read data from the SAS workspace
				OleDbConnection dbConnection = new OleDbConnection( "Provider=sas.iomprovider.1; SAS Workspace ID=" + ws.UniqueIdentifier );
				try
				{
					dbConnection.Open();
					// Use the data so we can get the columns
					string data = library + '.' + dataset;
					string selectclause = "select * from " + data;
					OleDbCommand cmdDB = new OleDbCommand( selectclause, dbConnection );
					OleDbDataReader dataReader = cmdDB.ExecuteReader( CommandBehavior.CloseConnection );

					try
					{
						int i = 0;
						while (dataReader.Read())
						{			
							if (dataReader.HasRows)
							{
								string variable = dataReader.GetName(i);
								string type = dataReader.GetDataTypeName(i++);

								if (!type.EndsWith("CHAR"))
								{
									// Numeric
									IconComboBoxItem item = new IconComboBoxItem(variable, 1);
									cmbCategoryVar.Items.Add(item);
									cmbSubgroupVar.Items.Add(item);
									cmbResponseVar.Items.Add(item);
									cmbWidthVar.Items.Add(item);
								}
								else
								{
									// Character
									IconComboBoxItem item = new IconComboBoxItem(variable, 0);
									cmbCategoryVar.Items.Add(item);
									cmbSubgroupVar.Items.Add(item);
								}
							}
						}
					}
					finally
					{
						dataReader.Close();
					}
				}
				catch{}
				finally
				{
					dbConnection.Close();
				}
			}

			int index = cmbCategoryVar.FindStringExact(categoryVar);
			if (index != -1)
				cmbCategoryVar.Text = categoryVar;		

			index = cmbResponseVar.FindStringExact(responseVar);
			if (index != -1)
				cmbResponseVar.Text = responseVar;		

			index = cmbWidthVar.FindStringExact(widthVar);
			if (index != -1)
				cmbWidthVar.Text = widthVar;		

			index = cmbSubgroupVar.FindStringExact(subgroupVar);
			if (index != -1)
				cmbSubgroupVar.Text = subgroupVar;		
		}

		private void SASCodeValidity()
		{
			ArrayList al = new ArrayList(4);
			// Keep the order the same as the enum Role order.
			al.Add(categoryVar);
			al.Add(responseVar);
			al.Add(widthVar);
			
			if (checkBox1.Checked)
				al.Add(subgroupVar);

			int count = al.Count;
			int i = 0;
			int j = 0;

			bool bDup = false;

			while(i < count  && !bDup)
			{
				string var = al[i].ToString();

				// No variable assigned
				if (var == string.Empty)
					break;

				while (++j < count)
				{
					string next = al[j].ToString();
					if (var == next)
					{
						string role = EnumToString((Role)i);
						string dupRole = EnumToString((Role)j);
						string message = string.Format("The {0} and {1} cannot contain the same variable.\nThe task will not continue", role, dupRole);
						MessageBox.Show(this, message,"Duplication Error", 
							MessageBoxButtons.OK, MessageBoxIcon.Error);

						bDup = true;
						break;
					}
				}
				i++;
				j = i;
			}

			string status = string.Empty;

			if (bDup)
			{
				status = "There are duplicate roles assigned.";
			}
			else if (cmbLibs.Text == string.Empty)
			{
				status = "The Library is not assigned.";
			}
			else if (cmbDatasets.Items.Count == 0)
			{
				status = string.Format("The library {0} contains no data sets.", library);
			}
			else if (cmbDatasets.Text == string.Empty)
			{
				status = "The Data Set is not assigned.";
			}
			else if (cmbCategoryVar.Text == string.Empty)
			{
				status = "The Category role is not assigned.";
			}
			else if (cmbResponseVar.Text == string.Empty)
			{
				status = "The Response role is not assigned.";
			}
			else if (cmbWidthVar.Text == string.Empty)
			{
				status = "The Width role is not assigned.";
			}
			else if (checkBox1.Checked && cmbSubgroupVar.Text == string.Empty)
			{
				status = "The Subgroup role is not assigned.";
			}
			else
			{
				btnOK.Enabled = true;
				btnOK.Focus();
				checkBox1.Enabled = true;
				statusBar1.Text = string.Empty;
			}
			if (status != string.Empty)
			{
				btnOK.Enabled = false;
				statusBar1.Text = status;
			}
		}

		private void InitializeUI()
		{
			// clear variables
			cmbCategoryVar.Items.Clear();
			categoryVar = string.Empty;

			cmbResponseVar.Items.Clear();
			responseVar = string.Empty;
			
			cmbWidthVar.Items.Clear();
			widthVar = string.Empty;

			cmbSubgroupVar.Items.Clear();
			subgroupVar = string.Empty;

			checkBox1.Checked = false;
			checkBox1.Enabled = false;

			rbPercentageWidth.Enabled = false;
			rbSumWidth.Enabled = false;

			rbSumWidth.Checked = true;
			rbSumSubgroup.Checked = true;
		}

		#endregion

		#region Event Handlers

		private void cmbServers_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			try
			{
				if (bUpdate)
				{
					// clear library
					library = string.Empty;

					cmbDatasets.Items.Clear();
					dataset = string.Empty;

					InitializeUI();
				}
				currServer = cmbServers.SelectedItem.ToString();

				PopulateLibraryList();

				SASCodeValidity();
			}
			catch
			{
				MessageBox.Show(string.Format("There was an error trying to connect to \"{0}\".", cmbServers.SelectedItem),"Connection error");
				cmbServers.SelectedItem = currServer;
			}
		}

		private void cmbLibs_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (bUpdate)
			{
				cmbDatasets.Items.Clear();
				dataset = string.Empty;

				InitializeUI();
			}

			library = cmbLibs.SelectedItem.ToString();
			PopulateDatasetList(library);

			SASCodeValidity();
		}

		private void cmbDatasets_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (bUpdate)
			{
				InitializeUI();
			}

			dataset = cmbDatasets.Text;

			PopulateVariableList();

			SASCodeValidity();

			Text = "Area Bar Chart for " + dataset;

			// Cannot continue if there are less than 2 numeric columns.
			if (cmbCategoryVar.Items.Count <= 2)
			{
				MessageBox.Show(this,"The data set does contain enough columns to create an Area Bar chart.\nPlease select a different data set.","Invalid data", 
					MessageBoxButtons.OK, MessageBoxIcon.Information);

				cmbDatasets.Focus();
			}
			else if (cmbResponseVar.Items.Count < 2)
			{
				MessageBox.Show(this,"The data set contains less than two numeric columns.\nPlease select a different data set.","Invalid data", 
					MessageBoxButtons.OK, MessageBoxIcon.Information);

				cmbDatasets.Focus();
			}
		}

		private void cmbCategoryVar_SelectedIndexChanged(object sender, EventArgs e)
		{
			categoryVar = cmbCategoryVar.Text;
			SASCodeValidity();
		}

		private void cmbResponseVar_SelectedIndexChanged(object sender, EventArgs e)
		{
			responseVar = cmbResponseVar.Text;
			SASCodeValidity();
		}

		private void cmbWidthVar_SelectedIndexChanged(object sender, EventArgs e)
		{
			widthVar = cmbWidthVar.Text;
			groupBox1.Enabled = true;
			rbPercentageWidth.Enabled = true;
			rbSumWidth.Enabled = true;
			SASCodeValidity();
		}

		private void cmbSubgroupVar_SelectedIndexChanged(object sender, EventArgs e)
		{
			subgroupVar = cmbSubgroupVar.Text;
			SASCodeValidity();
		}

		private void rbSumWidth_CheckedChanged(object sender, EventArgs e)
		{
			wstat = rbSumWidth.Checked ? "SUM" : "PERCENT";
		}

		private void rbPercentageWidth_CheckedChanged(object sender, EventArgs e)
		{
			wstat = (rbPercentageWidth.Checked) ? "PERCENT" : "SUM";
		}

		private void rbSumSubgroup_CheckedChanged(object sender, EventArgs e)
		{
			rstat = rbSumSubgroup.Checked ? "SUM" : "PERCENT";
		}

		private void rbPercentageSubgroup_CheckedChanged(object sender, EventArgs e)
		{
			rstat = rbPercentageSubgroup.Checked ? "PERCENT" : "SUM";
		}

		private void checkBox1_CheckStateChanged(object sender, EventArgs e)
		{
			bShowSubgroup = checkBox1.Checked;	
			if (bShowSubgroup)
			{
				label8.Enabled = true;
				cmbSubgroupVar.Enabled = true;
				groupBox2.Enabled = true;
				rbPercentageSubgroup.Enabled = true;
				rbSumSubgroup.Enabled = true;
			}
			else
			{
				label8.Enabled = false;
				cmbSubgroupVar.Enabled = false;
				rbPercentageSubgroup.Enabled = false;
				rbSumSubgroup.Enabled = false;
				groupBox2.Enabled = false;
			}

			SASCodeValidity();
		}

		protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
		{
			const int WM_KEYDOWN = 0x100;
			const int WM_SYSKEYDOWN = 0x104;

			if(msg.Msg == WM_KEYDOWN || msg.Msg == WM_SYSKEYDOWN)
			{
				switch(keyData)
				{
					case Keys.Escape: Close();
						break;
					case Keys.Return: 
						if (btnCancel.Focused)
							Close();
						else
							btnOK.Select();
						break;
				}
			}

			return base.ProcessCmdKey (ref msg, keyData);
		}

		#endregion

		#region Converstion method

		private string EnumToString(Role role)
		{
			string enum2string = string.Empty; 
			switch(role)
			{
				case Role.CATEGORY : enum2string =  "Category";
					break;
				case Role.RESPONSE : enum2string = "Response";
					break;
				case Role.WIDTH : enum2string = "Width";
					break;
				case Role.SUBGROUP : enum2string = "Subgroup";
					break;
				default : enum2string = null; // Invalid Role
					break;		
			}
			return enum2string;
		}

		#endregion 
	}
}
