PROC SORT
	DATA=WORK.PFJ(KEEP=AMOUNT INTEREST LABEL)
	OUT=WORK.PFJSORTED;
	BY LABEL;
RUN;

PROC TRANSPOSE DATA=WORK.PFJSORTED
	OUT=WORK.PFJTRANSPOSED(LABEL="Transposed WORK.PFJSORTED")
	PREFIX=Column
	NAME=Source
	LABEL=Label;
	BY LABEL;
	VAR AMOUNT INTEREST;
RUN; QUIT;

PROC GCHART DATA =WORK.PFJTRANSPOSED;
	PIE3D	 Source /
 	SUMVAR=Column1
	GROUP=LABEL
	TYPE=SUM
	NOLEGEND
	SLICE=OUTSIDE
	PERCENT=NONE
	VALUE=OUTSIDE
	OTHER=4
	OTHERLABEL="Other"
	ACROSS	=1
	COUTLINE=BLACK;
RUN; QUIT;
